/*
 * @version		$Id: allvideoshare.js 3.2.0 2018-06-30 $
 * @package		All Video Share
 * @copyright   Copyright (C) 2012-2018 MrVinoth
 * @license     GNU/GPL http://www.gnu.org/licenses/gpl-2.0.html
*/

jQuery( document ).ready(function() {
		
	// Video Submission Form: On file adding method changed
	jQuery( 'input[type="radio"]', '.avs-file-uploader-types' ).on( 'change', function() {
																					   
		var type;
		
		if ( this.checked ) {
			type = this.value;
		} else {
			type = ( 'url' == this.value ) ? 'upload' : 'url';
		}
		
		jQuery( this ).closest( '.avs-file-uploader' ).find( '.avs-file-uploader-type' ).hide();
		jQuery( this ).closest( '.avs-file-uploader' ).find( '.avs-file-uploader-type-' + type ).show();
		jQuery( '#type', '#avs-videos' ).trigger( 'change' );
		
	});
	
	// Video Submission Form: On file browse button clicked
	jQuery( '.avs-btn-upload' ).on( 'click', function() {
													  
		var $element = jQuery( this ).closest( '.avs-file-uploader-type-upload' );
		
		$element.find( 'input[type="file"]' ).off( 'change' ).on( 'change', function() {
																					 
			var value = jQuery( this ).val().split( '\\' ).pop();
			$element.find( 'input[type="text"]' ).val( value );
			
		}).trigger( 'click' );     
		
	});
	
	// Video Submission Form: On type change
	jQuery( '#type', '#avs-videos' ).on( 'change', function() {
					
		var type = jQuery( this ).val();
		
		jQuery( '.avs-toggle-fields', '#avs-videos' ).hide();
		jQuery( '.avs-'+type+'-fields', '#avs-videos' ).show();
		
		// Set required
		jQuery( '#video, #upload-video, #streamer, #external, #hls', '#avs-videos' ).removeClass( 'required' ).removeAttr( 'required' );
		
		switch ( type ) {
			case 'general':
				var option = jQuery( '#avs-file-uploader-video', '#avs-videos' ).find( 'input[type="radio"]:checked' ).val();
				
				if ( 'url' == option ) {
					jQuery( '#video', '#avs-videos' ).addClass( 'required' );
				} else {
					jQuery( '#upload-video', '#avs-videos' ).addClass( 'required' );
				}
				break;
			case 'youtube':
				jQuery( '#external', '#avs-videos' ).addClass( 'required' );
				break;
			case 'vimeo':
				jQuery( '#external', '#avs-videos' ).addClass( 'required' );
				break;
			case 'rtmp':
				jQuery( '.avs-hls-fields', '#avs-videos' ).find( '.star' ).hide();
				jQuery( '#streamer, #external', '#avs-videos' ).addClass( 'required' );
				break;
			case 'hls':
				jQuery( '#hls', '#avs-videos' ).addClass( 'required' );
				jQuery( '.avs-hls-fields', '#avs-videos' ).find( '.star' ).show();
				break;
		}
		
	}).trigger( 'change' );
	
	// MediaElement
	if ( jQuery.fn.mediaelementplayer !== undefined ) {
		
		jQuery( '.avs-player' ).each(function() {
											  
			var $this    = jQuery( this );
			var baseURL  = $this.data( 'baseurl' );
			var loop     = parseInt( $this.data( 'loop' ) );
			var autoplay = parseInt( $this.data( 'autoplay' ) );		
			var features = [ 'playpause' ];
			
			if ( ! $this.attr( 'data-no-current' ) ) {
				features.push( 'current' );
			}
			
			features.push( 'progress' );
			
			if ( ! $this.attr( 'data-no-duration' ) ) {
				features.push( 'duration' );
			}
			
			if ( ! $this.attr( 'data-no-quality' ) ) {
				features.push( 'quality' );
			}
			
			features.push( 'volume' );
			
			if ( ! $this.attr( 'data-no-fullscreen' ) ) {
				features.push( 'fullscreen' );
			}
			
			if ( $this.attr( 'data-no-controlbar' ) ) {
				features = [];
			}
			
			features.push( 'contextmenu' );
			features.push( 'me' );
			
			jQuery( 'video', this ).mediaelementplayer({
				pluginPath   : baseURL + 'components/com_allvideoshare/assets/mediaelement/',
				features     : features,
				startVolume  : parseInt( $this.data( 'volumelevel' ) ) / 100,
				licenseKey   : $this.attr( 'data-key' ),
				hideLOGO     : ( parseInt( $this.attr( 'data-hide-logo' ) ) ? true : false ),
				logoImage    : $this.attr( 'data-logo' ),
				logoPosition : $this.attr( 'data-logo-pos' ),
				logoOpacity  : ( parseInt( $this.attr( 'data-logo-alp' ) ) / 100 ),
				logoClickURL : $this.attr( 'data-logo-target' ),
				youtube      : { showinfo : 0, rel : 0, iv_load_policy : 3 },
				success      : function( media ) {
	
					$this.on( 'noCommercialFound', function() {
						$this.off( 'noCommercialFound commercialEnded' );
						if( autoplay ) media.play();
					}).on( 'commercialEnded', function() {
						$this.off( 'noCommercialFound commercialEnded' );
						media.play();
					}).avsCommercials( 'preroll' );
					
					media.addEventListener( 'loadeddata', function( e ) {
						//console.log( 'Media data is loaded' );
					});
					
					media.addEventListener( 'loadedmetadata', function( e ) {
						//console.log( 'Meta data (like dimensions and duration) are loaded' );
					});
					
					media.addEventListener( 'progress', function( e ) {
						//console.log( 'Browser is in the process of getting the media data' );
					});
					
					media.addEventListener( 'timeupdate', function( e ) {
						//console.log( 'The playing position has changed (like when the user fast forwards to a different point in the media)' );
					});
					
					media.addEventListener( 'seeked', function( e ) {
						//console.log( 'The seeking attribute is set to false indicating that seeking has ended' );
					});
					
					media.addEventListener( 'canplay', function( e ) {
						//console.log( 'A file is ready to start playing (when it has buffered enough to begin)' );
					});
					
					media.addEventListener( 'play', function( e ) {
						//console.log( 'The media is ready to start playing' );	
					});
					
					media.addEventListener( 'playing', function( e ) {
						//console.log( 'The media actually has started playing' );
					});
					
					media.addEventListener( 'pause', function( e ) {
						//console.log( 'The media is paused either by the user or programmatically' );
					});
					
					media.addEventListener( 'ended', function( e ) {
						//console.log( 'The media has reach the end (a useful event for messages like "thanks for listening")' );
						
						$this.on( 'noCommercialFound commercialEnded', function() {
							$this.off( 'noCommercialFound commercialEnded' );
							if( loop ) media.play();
						}).avsCommercials( 'postroll' );
					});
					
					media.addEventListener( 'volumechange', function( e ) {
						//console.log( 'Volume is changed (including setting the volume to "mute")' );
					});
					
				}
			});
												
		});
		
	}
	
});

// Add Preroll or Postroll ads
(function( $ ) {
		  
	$.fn.avsCommercials = function( type ) {
		
		return this.each(function() {
			
			var $this = $( this ),
				error = 1;
			
			if ( $this.attr( 'data-' + type + '-id' ) ) {
				
				// Vars
				var id       = $this.data( type + '-id' ),
					video    = $this.data( type + '-video' ),
					autoplay = parseInt( $this.data( 'autoplay' ) ),
					baseURL  = $this.data( 'baseurl' );
	
				// Check if this browser can play the ad video
				var ext      = video.split( '.' ).pop(),
				    canPlay  = false;
	
				if ( /mp4|webm|ogg/.test( ext ) ) {
					var elem = document.createElement( 'video' );
					canPlay = ( elem.canPlayType( 'video/' + ext ) !== '' ) ? true : false;
				}
					
				// Proceed if the browser can play the ad video
				if ( canPlay ) {
					
					error = 0;
					
					var html = '<div class="avs-commercials">' + 
						'<div class="avs-commercials-content">' +
							'<div class="avs-commercials-bg"></div>' +
							'<div class="avs-commercials-media"></div>' +
							'<div class="avs-commercials-status-bar"></div>' +
							'<div class="avs-commercials-progress"></div>' +
						'</div>' +
					'</div>';
					
					$this.append( html );
					
					var $commercials_elem = $this.find( '.avs-commercials' ),
						$media_elem = $this.find( '.avs-commercials-media' ),
						$progress_elem = $this.find( '.avs-commercials-progress' );
						
					$commercials_elem.on( 'click', function() {
								
						$commercials_elem.unbind( 'click' ).on( 'click', function() { 
							window.open( baseURL + 'index.php?option=com_allvideoshare&view=commercials&task=click&tmpl=component&id=' + id, '_blank' );
						});
						
						$this.find( '.avs-commercials-status-bar' ).html( 'Loading...' );
						$this.find( '.avs-commercials-content' ).addClass( 'active' );	
							
						$media_elem.append( '<video><source type="video/'+ext+'" src="' + video + '" /></video>' );
						
						var $commercial = $media_elem.find( 'video' );
						
						$commercial[0].play();
						
						$commercial[0].onplay = function() {
   				 			$this.find( '.avs-commercials-status-bar' ).html( 'ADVERTISEMENT' );
						};
						
						$commercial[0].addEventListener( 'timeupdate', function() {
							if( 4 === this.readyState ) {
    							var percentage = ( this.currentTime / this.duration ) * 100;
								$progress_elem.css( 'width', percentage + '%' );
							}
						});
						
						$commercial[0].onended = function() {
   				 			$commercials_elem.remove();
							$this.trigger( 'commercialEnded' );
						};	
						
						// Update impressions
						var xmlhttp;

   						if ( window.XMLHttpRequest ) {
   							xmlhttp = new XMLHttpRequest();
   						} else {
   							xmlhttp = new ActiveXObject( "Microsoft.XMLHTTP" );
   						};
						
						xmlhttp.onreadystatechange = function() {
   							if( xmlhttp.readyState == 4 && xmlhttp.status == 200 ) {
								if( xmlhttp.responseText ) {
									// Console.log( 'Impressions count updated!' );
								}
       						}
   						};	

						xmlhttp.open( 'GET', baseURL + 'index.php?option=com_allvideoshare&view=commercials&task=impressions&format=raw&id=' + id, true );
   						xmlhttp.send();
						
					});
					
					// Trigger the playback
					if ( autoplay || 'postroll' == type ) {
						$commercials_elem.trigger( 'click' );
					};
					
				}
				
			}		
			
			if ( error ) {
				$this.trigger( 'noCommercialFound' );
			};
			
		});
		
	}
		  
}( jQuery ));

// Custom Context Menu
(function( $ ) {
	 
	if ( jQuery.fn.mediaelementplayer !== undefined ) {
		
		Object.assign(MediaElementPlayer.prototype, {
		
			buildcontextmenu: function buildcontextmenu( player, controls, layers, media ) {
				
				var t = this;
	
				if ( '' != t.options.copyrightText ) {
					t.options.siteName = $( t.node ).closest( '.avs-player' ).data( 'sitename' );
				}
				
				if ( '' != t.options.siteUrl ) {
					t.options.siteUrl = $( t.node ).closest( '.avs-player' ).data( 'baseurl' );
				}
				
				t.contextMenu = document.querySelector( '.' + t.options.classPrefix + 'contextmenu' );
				
				if ( ! t.contextMenu ) {
					t.contextMenu = document.createElement( 'div' );
					t.contextMenu.className = t.options.classPrefix + 'contextmenu';
					t.contextMenu.innerHTML = '<div class="' + t.options.classPrefix + 'contextmenu-item">' + t.options.siteName + '</div>';
					t.contextMenu.style.display = 'none';
	
					document.body.appendChild( t.contextMenu );
					
					document.addEventListener( 'contextmenu', function() {
						t.contextMenu.style.display = 'none';								 
					});
					
					document.addEventListener( 'click', function() {
						t.contextMenu.style.display = 'none';								 
					});
				}
				
				t.container.addEventListener( 'contextmenu', function( e ) {
					if ( e.keyCode === 3 || e.which === 3 ) {
						e.preventDefault();
						e.stopPropagation();
						
						var width = t.contextMenu.offsetWidth,
							height = t.contextMenu.offsetHeight,
							x = event.pageX,
							y = event.pageY,
							doc = document.documentElement,
							scrollLeft = ( window.pageXOffset || doc.scrollLeft ) - ( doc.clientLeft || 0 ),
							scrollTop = ( window.pageYOffset || doc.scrollTop ) - ( doc.clientTop || 0 ),
							left = x + width > window.innerWidth + scrollLeft ? x - width : x,
							top = y + height > window.innerHeight + scrollTop ? y - height : y;
				
						t.contextMenu.style.display = '';
						t.contextMenu.style.left = left + 'px';
						t.contextMenu.style.top = top + 'px';				
					}
				});
				
				t.contextMenuItem = t.contextMenu.querySelector( '.' + t.options.classPrefix + 'contextmenu-item' );
				t.contextMenuItem.addEventListener( 'click', function() {
					window.location.href = t.options.siteUrl;
				});
						
			}
				
		});
	
	}

})( jQuery );